<script setup lang="ts">
    import { Intervention } from '@/interventionServiceOffer/entities/intervention/Intervention'

    import SCarousel from '@/shared/document/components/SCarousel.vue'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import {
        isDefined,
        isUndefined,
        requiredInject,
    } from '@/shared/helpers/types'
    import { computed, ref, toRef } from 'vue'
    import { useMsal } from '@/plugins/msal/useMsal'
    import SInterventionCycleEntityBasicDetails from '@/interventionServiceOffer/components/interventionCycleEntity/SInterventionCycleEntityBasicDetails.vue'
    import SMultiLinks from '@/shared/button/components/SMultiLinks.vue'
    import SObjectStatusHistory from '@/shared/objectStatus/components/SObjectStatusHistory.vue'
    import { formatageDatePourAffichage } from '@/shared/helpers/dates'
    import SAttributeAndValue from '@/shared/ui/components/SAttributeAndValue.vue'
    import { useIntervention } from '@/interventionServiceOffer/entities/intervention/useIntervention'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferTrackingCategoryInjectionKey,
    } from '@/shared/constants'
    import SInterventionModification from './SInterventionModification.vue'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { getAnalyticsProvider } from '@/shared/analytics/AnalyticsProvider'
    import SInterventionSoldage from './SInterventionSoldage.vue'
    import { ItemLists } from '@/interventionServiceOffer/composables/equipement/useItemLists'
    import { confirmBeforeCancel } from '@/shared/helpers/prompts'
    import SFormDialog from '../global/SFormDialog.vue'
    const serviceOfferTrackingCategory = requiredInject(
        serviceOfferTrackingCategoryInjectionKey
    )
    const props = withDefaults(
        defineProps<{
            interventionId: Intervention['id']
            displayHeader?: boolean
            displayContent?: boolean
        }>(),
        {
            displayHeader: true,
            displayContent: true,
        }
    )

    const emit = defineEmits<{
        (e: 'selectItem', itemType: keyof ItemLists, itemId: string): void
        (e: 'updateIntervention'): void
        (e: 'solderIntervention'): void
    }>()

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)

    const {
        intervention,
        interventionStatusHistory,
        demandesInterventionsOriginales,
        reload: reloadIntervention,
    } = useIntervention(
        toRef(props, 'interventionId'),
        serviceOfferId,
        true,
        true
    )

    const displayLinkedDemandesInterventionsBlock = computed(() => {
        // Si on est encore en chargement on affiche le block
        if (isUndefined(intervention.value?.data)) {
            return true
        }
        if (
            isUndefined(intervention.value.data.demandeInterventionIds) ||
            intervention.value.data.demandeInterventionIds.length === 0
        ) {
            return false
        }
        return true
    })

    const LUtilisateurALaPermissionDeModifierDesInterventions = computed(() => {
        return userStore.currentUserHasRoleForServiceOffer(
            'INTERVENTION_MODIFIER_INTERVENTIONS',
            serviceOfferId.value
        )
    })

    const LUtilisateurALaPermissionDeSolderDesInterventions = computed(() => {
        return (
            isDefined(intervention.value?.data) &&
            userStore.currentUserHasRoleForServiceOffer(
                'INTERVENTION_SOLDER_INTERVENTIONS',
                serviceOfferId.value
            ) &&
            intervention.value.data.isClosable() === true
        )
    })

    const modificationInterventionDialogIsActive = ref(false)
    const interventionCreationFormRef = ref<
        InstanceType<typeof SInterventionModification> | undefined
    >()

    async function mettreÀJourIntervention() {
        if (isUndefined(interventionCreationFormRef.value)) {
            return
        }
        if (isUndefined(intervention.value?.data)) {
            return
        }

        const updatedIntervention =
            await interventionCreationFormRef.value.mettreÀJourIntervention()
        modificationInterventionDialogIsActive.value = false

        emitSnackBar(`Intervention mise à jour`, 'primary')
        getAnalyticsProvider().sendEvent(
            serviceOfferTrackingCategory.value,
            "Modification d'intervention",
            `${updatedIntervention.code} : ${updatedIntervention.title}`
        )
        emit('updateIntervention')
        await reloadIntervention()
    }

    const soldageInterventionDialogIsActive = ref(false)
    const interventionSoldageFormRef = ref<
        InstanceType<typeof SInterventionSoldage> | undefined
    >()

    async function enregistrerTraitementIntervention() {
        if (isUndefined(interventionSoldageFormRef.value)) {
            return
        }
        if (isUndefined(intervention.value?.data)) {
            return
        }

        await interventionSoldageFormRef.value.sauvegarderTraitementIntervention()
        emitSnackBar(
            `Traitement de l'intervention "${intervention.value.data.title}" sauvegardé`,
            'primary'
        )
        getAnalyticsProvider().sendEvent(
            serviceOfferTrackingCategory.value,
            "Sauvegarde traitement d'intervention",
            `${intervention.value.data.code} : ${intervention.value.data.title}`
        )

        emit('updateIntervention')
        await reloadIntervention()
    }
    async function solderIntervention() {
        if (isUndefined(interventionSoldageFormRef.value)) {
            return
        }
        if (isUndefined(intervention.value?.data)) {
            return
        }

        await interventionSoldageFormRef.value.sauvegarderEtSolderIntervention()
        soldageInterventionDialogIsActive.value = false
        emitSnackBar(
            `Intervention "${intervention.value.data.title}" terminée`,
            'success'
        )
        getAnalyticsProvider().sendEvent(
            serviceOfferTrackingCategory.value,
            "Soldage d'intervention",
            `${intervention.value.data.code} : ${intervention.value.data.title}`
        )

        emit('solderIntervention')
        await reloadIntervention()
    }
</script>

<template>
    <div>
        <v-skeleton-loader
            v-if="
                isUndefined(intervention) ||
                isUndefined(interventionStatusHistory)
            "
            type="article"
        >
        </v-skeleton-loader>

        <template v-if="isDefined(intervention?.data)">
            <template v-if="displayHeader">
                <v-img
                    v-if="
                        intervention.data.getToutesLesImagesCatégorisées()
                            .length > 0
                    "
                    :height="$vuetify.display.mdAndUp ? 200 : 100"
                    cover
                    :src="
                        intervention.data.getToutesLesImagesCatégorisées()[0]
                            .image.url.href
                    "
                >
                </v-img>

                <v-card-title
                    :class="
                        intervention.data.getToutesLesImagesCatégorisées()
                            .length > 0
                            ? ''
                            : 'pr-10'
                    "
                >
                    {{ intervention.data.title }}
                </v-card-title>
                <v-card-text class="d-flex flex-wrap pb-0" style="gap: 12px">
                    <v-chip
                        :data-cy="`priority-${intervention.data.priority}`"
                        size="small"
                        variant="flat"
                        :color="
                            Intervention.getPriorityColor(
                                intervention.data.priority
                            )
                        "
                        class="text-capitalize"
                    >
                        {{ intervention.data.priority }}
                    </v-chip>
                    <v-chip
                        data-cy="current-status"
                        size="small"
                        variant="flat"
                        color="disabled"
                    >
                        {{ intervention.data.currentStatus?.label }}
                    </v-chip>
                    <v-chip
                        v-if="intervention.data.actionType !== undefined"
                        data-cy="action-type"
                        size="small"
                        variant="flat"
                        color="primary"
                    >
                        {{ intervention.data.actionType.label }}
                    </v-chip>
                </v-card-text>

                <template
                    v-if="
                        LUtilisateurALaPermissionDeModifierDesInterventions ||
                        LUtilisateurALaPermissionDeSolderDesInterventions
                    "
                >
                    <v-card-actions>
                        <v-btn
                            v-if="
                                LUtilisateurALaPermissionDeModifierDesInterventions
                            "
                            prepend-icon="mdi-pencil-outline"
                            class="d-print-none"
                            data-cy="edit-intervention-button"
                            @click="
                                modificationInterventionDialogIsActive = true
                            "
                        >
                            Modifier
                        </v-btn>
                        <s-form-dialog
                            v-model="modificationInterventionDialogIsActive"
                            :title="
                                'Modification de l\'intervention ' +
                                intervention.data.title
                            "
                            :form-is-loading="
                                interventionCreationFormRef?.isProcessing
                            "
                            @close-dialog="
                                () =>
                                    confirmBeforeCancel(
                                        () => {
                                            modificationInterventionDialogIsActive = false
                                        },
                                        undefined,
                                        !interventionCreationFormRef?.isDirty
                                    )
                            "
                        >
                            <SInterventionModification
                                ref="interventionCreationFormRef"
                                :intervention-originale="intervention.data"
                            />
                            <template #actions>
                                <v-btn
                                    variant="flat"
                                    prepend-icon="mdi-check"
                                    :loading="
                                        interventionCreationFormRef?.isProcessing
                                    "
                                    :disabled="
                                        !interventionCreationFormRef?.formFieldsAreValid
                                    "
                                    @click="mettreÀJourIntervention()"
                                >
                                    Modifier
                                </v-btn>
                            </template>
                        </s-form-dialog>
                        <v-btn
                            v-if="
                                LUtilisateurALaPermissionDeSolderDesInterventions
                            "
                            prepend-icon="mdi-check-all"
                            class="d-print-none"
                            data-cy="traiter-intervention-button"
                            @click="soldageInterventionDialogIsActive = true"
                        >
                            Traiter
                        </v-btn>
                        <s-form-dialog
                            v-model="soldageInterventionDialogIsActive"
                            :title="
                                'Solder l\'intervention ' +
                                intervention.data.title
                            "
                            :form-is-loading="
                                interventionSoldageFormRef?.isProcessing
                            "
                            @close-dialog="
                                () =>
                                    confirmBeforeCancel(
                                        () => {
                                            soldageInterventionDialogIsActive = false
                                        },
                                        undefined,
                                        !interventionSoldageFormRef?.isDirty
                                    )
                            "
                        >
                            <SInterventionSoldage
                                ref="interventionSoldageFormRef"
                                :intervention-originale="intervention.data"
                            />
                            <template #actions>
                                <v-btn
                                    variant="flat"
                                    prepend-icon="mdi-content-save"
                                    :loading="
                                        interventionSoldageFormRef?.isProcessing
                                    "
                                    :disabled="
                                        !interventionSoldageFormRef?.isSaveableForm
                                    "
                                    @click="enregistrerTraitementIntervention()"
                                >
                                    Enregistrer
                                </v-btn>
                                <v-btn
                                    variant="flat"
                                    prepend-icon="mdi-check-all"
                                    :loading="
                                        interventionSoldageFormRef?.isProcessing
                                    "
                                    :disabled="
                                        !interventionSoldageFormRef?.isSoldableForm
                                    "
                                    @click="solderIntervention()"
                                >
                                    Solder
                                </v-btn>
                            </template>
                        </s-form-dialog>
                    </v-card-actions>
                </template>

                <v-divider></v-divider>
            </template>

            <v-card-text v-if="displayContent">
                <v-row>
                    <v-col cols="12">
                        <h2 class="mb-1">
                            <v-icon>mdi-traffic-cone</v-icon>
                            Intervention
                        </h2>
                        <s-attribute-and-value
                            cypress-selector="dates"
                            attribut="dates"
                        >
                            {{
                                intervention.data.dateDeDebut
                                    ? 'Du ' +
                                      formatageDatePourAffichage(
                                          intervention.data.dateDeDebut,
                                          'minute'
                                      )
                                    : ''
                            }}
                            {{
                                intervention.data.dateDeFin
                                    ? 'au ' +
                                      formatageDatePourAffichage(
                                          intervention.data.dateDeFin,
                                          'minute'
                                      )
                                    : ''
                            }}
                        </s-attribute-and-value>
                        <s-intervention-cycle-entity-basic-details
                            :entity="intervention.data"
                            entity-type="interventions"
                            :display-title="false"
                            @select-item="
                                (...args) => $emit('selectItem', ...args)
                            "
                        />
                        <p class="mt-3">
                            <s-object-status-history
                                v-if="
                                    isDefined(interventionStatusHistory?.data)
                                "
                                :object-status-history="
                                    interventionStatusHistory.data
                                "
                            />
                        </p>
                    </v-col>

                    <v-col
                        v-if="displayLinkedDemandesInterventionsBlock"
                        cols="12"
                    >
                        <v-skeleton-loader
                            v-if="isUndefined(demandesInterventionsOriginales)"
                            type="article"
                        ></v-skeleton-loader>
                        <div
                            v-if="
                                isDefined(demandesInterventionsOriginales?.data)
                            "
                            data-cy="linked-demandes-info"
                        >
                            <h2
                                v-if="
                                    demandesInterventionsOriginales.data
                                        .length > 0
                                "
                                class="mb-1"
                            >
                                <v-icon>mdi-comment-question-outline</v-icon>
                                {{
                                    demandesInterventionsOriginales.data
                                        .length > 1
                                        ? 'Demandes initiales'
                                        : 'Demande initiale'
                                }}
                            </h2>

                            <template
                                v-for="(
                                    linkedDemande, index
                                ) in demandesInterventionsOriginales.data"
                                :key="linkedDemande.id"
                            >
                                <v-divider
                                    v-if="index > 0"
                                    class="my-3"
                                ></v-divider>
                                <s-intervention-cycle-entity-basic-details
                                    :entity="linkedDemande"
                                    entity-type="demandes"
                                    :display-title="true"
                                    details-link
                                    :data-cy="
                                        'linked-demande-info-' +
                                        linkedDemande.code
                                    "
                                    @select-item="
                                        (...args) =>
                                            $emit('selectItem', ...args)
                                    "
                                />
                            </template>
                        </div>
                    </v-col>
                    <v-col v-if="intervention.data.hasImage()" cols="12">
                        <div class="d-block d-print-none">
                            <s-carousel
                                v-if="
                                    intervention.data.getToutesLesImagesCatégorisées()
                                        .length > 1
                                "
                            >
                                <v-carousel-item
                                    v-for="imageEtCatégorie in intervention.data.getToutesLesImagesCatégorisées()"
                                    :key="imageEtCatégorie.image.id"
                                >
                                    <v-img
                                        :src="imageEtCatégorie.image.url.href"
                                        class="h-100 bg-grey-lighten-1"
                                        data-cy="image"
                                    >
                                        <v-chip
                                            class="ma-2"
                                            variant="flat"
                                            data-cy="image-categorie"
                                            style="
                                                background-color: rgba(
                                                    0,
                                                    0,
                                                    0,
                                                    0.7
                                                );
                                            "
                                            >{{
                                                imageEtCatégorie.catégorie
                                            }}</v-chip
                                        >
                                    </v-img>
                                </v-carousel-item>
                            </s-carousel>
                            <v-img
                                v-if="
                                    intervention.data.getToutesLesImagesCatégorisées()
                                        .length === 1
                                "
                                :src="intervention.data.getItemImageUrl()?.href"
                                data-cy="image"
                            >
                                <v-chip
                                    class="ma-2"
                                    variant="flat"
                                    data-cy="image-categorie"
                                    style="background-color: rgba(0, 0, 0, 0.7)"
                                    >{{
                                        intervention.data
                                            .getToutesLesImagesCatégorisées()
                                            .pop()?.catégorie
                                    }}</v-chip
                                >
                            </v-img>
                        </div>
                        <div class="d-none d-print-block">
                            <div>
                                <v-col
                                    v-for="imageEtCatégorie in intervention.data.getToutesLesImagesCatégorisées()"
                                    :key="imageEtCatégorie.image.id"
                                    cols="6"
                                >
                                    <span>{{
                                        imageEtCatégorie.catégorie
                                    }}</span>
                                    <div>
                                        <img
                                            :src="
                                                imageEtCatégorie.image.url.href
                                            "
                                            alt="Photo de l'intervention"
                                            style="height: 6cm"
                                        />
                                    </div>
                                </v-col>
                            </div>
                        </div>
                    </v-col>
                    <v-col
                        v-if="intervention.data.intervenantsAffectes.length > 0"
                        cols="12"
                    >
                        <v-list>
                            <h2 class="mb-1">
                                <v-icon>mdi-account-group-outline</v-icon>

                                Intervenants affectés
                            </h2>
                            <v-list-item
                                v-for="intervenant in intervention.data
                                    .intervenantsAffectes"
                                :key="intervenant.id"
                                data-cy="intervenants-affectes"
                            >
                                <v-list-item-title>
                                    <s-multi-links
                                        icon="mdi-phone-outline"
                                        :button-actions="
                                            intervenant.getTelephonesButtonActions()
                                        "
                                    >
                                        {{ intervenant.nomComplet }}
                                    </s-multi-links>
                                </v-list-item-title>
                            </v-list-item>
                        </v-list>
                    </v-col>

                    <v-col
                        v-if="intervention.data.documentsJoints.length !== 0"
                        cols="12"
                        data-cy="download-documents-list"
                    >
                        <v-list-item title="Documents"> </v-list-item>
                        <v-divider></v-divider>
                        <v-list>
                            <v-list-item
                                v-for="document in intervention.data
                                    .documentsJoints"
                                :key="document.id"
                                :href="document.url.href"
                                target="_blank"
                                prepend-icon="mdi-file-download-outline"
                            >
                                {{ document.name }}
                            </v-list-item>
                        </v-list>
                    </v-col>
                </v-row>
            </v-card-text>
        </template>
    </div>
</template>
